#ifndef __LIGHT_H
#define __LIGHT_H

#include <yafray_config.h>

#include <yafray/core/extern/vector3d.h>
#include <yafray/core/extern/color.h>
#include <yafray/core/extern/surface.h>
#include <yafray/core/extern/configurable.h>


__BEGIN_YAFRAY

class scene_t;
/*
class lightSource_t : public configurable_t
{
	public:
		// Amount of energy per surface unit that arrives the surface point
		virtual color_t energy(const surfacePoint_t &sp,const scene_t &scene,CFLOAT importance)const=0;
		// How much of that energy is reflected speculary in eye direction
		virtual color_t specular(const surfacePoint_t &sp,const vector3d_t &eye,
															const color_t &energy,CFLOAT hard)const=0;
		// total amount of emitted energy
		virtual color_t totalEnergy()const=0;
		virtual ~lightSource_t() {};
};
*/

struct energy_t
{
	energy_t(): segment(point3d_t(0,0,0), point3d_t(0,0,1)) {};

	segment_t segment;
	color_t color;
};

class light_t : public configurable_t
{
	public:
		virtual ~light_t() {};
		
		virtual CFLOAT luminance()const=0;
		// For direct lighting, sample from a point
		virtual void getSample(const point3d_t &from, energy_t &energy)=0;
		// For indirect lighting, shoot anywhere
		virtual void getSample(energy_t &energy)=0;
};

__END_YAFRAY

#endif
