#ifndef __TOOLS_H
#define __TOOLS_H

#ifdef HAVE_CONFIG_H
#include<yafray_config.h>
#endif

#define v_foreach(type,ite,vec) \
  for(std::vector<type>::iterator ite=(vec).begin();ite!=(vec).end();++ite)

#define v_foreach_const(type,ite,vec) \
  for(std::vector<type>::const_iterator ite=(vec).begin();ite!=(vec).end();++ite)

#define l_foreach(type,ite,vec) \
  for(std::list<type>::iterator ite=(vec).begin();ite!=(vec).end();++ite)

#define l_foreach_const(type,ite,vec) \
  for(std::list<type>::const_iterator ite=(vec).begin();ite!=(vec).end();++ite)



__BEGIN_YAFRAY

void * trackNew(void *p, const char *f, int l);
void * trackDelete(void *p, const char *f, int l);
void testAllocated(const void *p, const char *f, int l);

__END_YAFRAY


template<class T>
inline T * __tn(T *p,const char *f, int l)
{
	return (T *)yafray::trackNew((void *)p,f,l);
}

template<class T>
inline T * __td(T *p,const char *f, int l)
{
	return (T *)yafray::trackDelete((void *)p,f,l);
}

template<class T>
inline void __ta(const T *p, const char *f, int l)
{
	yafray::testAllocated((void *)p,f,l);
}

//#define _tn(P) __tn(P, __FILE__, __LINE__)
//#define _td(P) __td(P, __FILE__, __LINE__)
//#define _ta(P) __ta(P, __FILE__, __LINE__)

#define _tn(P) P
#define _td(P) P
#define _ta(P) P

#endif
