#ifndef __POINTLIGHT_H
#define __POINTLIGHT_H

#include <yafray/core/extern/light.h>
#include <yafray/core/extern/mcqmc.h>


__BEGIN_YAFRAY

class pointLight_t : public light_t
{
	public:
		pointLight_t();
		virtual ~pointLight_t() { delete [] _td(HSEQ);};
		
		virtual CFLOAT luminance()const;
		virtual void getSample(const point3d_t &from, energy_t &energy);
		virtual void getSample(energy_t &energy);
	protected:
		vector3d_t N,U,V;

		color_t color;
		CFLOAT power;
		point3d_t position;
		Halton *HSEQ;
};

__END_YAFRAY

#endif
