/****************************************************************************
 *
 * 			pointlight.h: Point light api 
 *      This is part of the yafray package
 *      Copyright (C) 2002 Alejandro Conty Estevez
 *
 *      This library is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU Lesser General Public
 *      License as published by the Free Software Foundation; either
 *      version 2.1 of the License, or (at your option) any later version.
 *
 *      This library is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *      Lesser General Public License for more details.
 *
 *      You should have received a copy of the GNU Lesser General Public
 *      License along with this library; if not, write to the Free Software
 *      Foundation,Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *      
 */
#ifndef Yafray_PointLight_Header
#define Yafray_PointLight_Header

#include <yafray_config.h>

#include <yafray/core/extern/light.h>

__BEGIN_YAFRAY

class pointLight_t : public lightSource_t
{
	public:
		pointLight_t();
		virtual void init(scene_t &scene);

		virtual color_t energy(const surfacePoint_t &sp,const scene_t &scene,CFLOAT importance)const;
		virtual color_t specular(const surfacePoint_t &sp,const vector3d_t &eye,
															const color_t &energy,CFLOAT hard)const;
		virtual color_t totalEnergy()const;
		virtual ~pointLight_t() {};
		
		static configurable_t *factory();

	protected:
		point3d_t from;
		color_t color;
		bool cast_shadows;
		CFLOAT pow;
};

__END_YAFRAY
#endif
