#include <yafray/core/extern/configurable.h>
#include <iostream>

using namespace std;

__BEGIN_YAFRAY

bool configurable_t::set(const char *attr,GFLOAT value)
{
	map<const char *,GFLOAT *, strless>::iterator i=float_map.find(attr);
	if(i!=float_map.end()) *(i->second)=value;
	else cerr<<"setting unexisting attr"<<attr<<endl;
	return i!=float_map.end();
}

bool configurable_t::set(const char *attr,bool value)
{
	map<const char *,bool *, strless>::iterator i=bool_map.find(attr);
	if(i!=bool_map.end()) *(i->second)=value;
	else cerr<<"setting unexisting attr"<<attr<<endl;
	return i!=bool_map.end();
}

bool configurable_t::set(const char *attr,int value)
{
	map<const char *,int *, strless>::iterator i=int_map.find(attr);
	if(i!=int_map.end()) *(i->second)=value;
	else cerr<<"setting unexisting attr"<<attr<<endl;
	return i!=int_map.end();
}

bool configurable_t::set(const char *attr,const char *str)
{
	map<const char *,string *, strless>::iterator i=str_map.find(attr);
	if(i!=str_map.end()) *(i->second)=str;
	else cerr<<"setting unexisting attr"<<attr<<endl;
	return i!=str_map.end();
}

bool configurable_t::set(const char *attr,const color_t &color)
{
	map<const char *,color_t *, strless>::iterator i=color_map.find(attr);
	if(i!=color_map.end()) *(i->second)=color;
	else cerr<<"setting unexisting attr"<<attr<<endl;
	return i!=color_map.end();
}

bool configurable_t::set(const char *attr,const vector3d_t &vec)
{
	map<const char *,vector3d_t *, strless>::iterator i=vector_map.find(attr);
	if(i!=vector_map.end()) *(i->second)=vec;
	else cerr<<"setting unexisting attr"<<attr<<endl;
	return i!=vector_map.end();
}

bool configurable_t::set(const char *attr,const point3d_t &p)
{
	map<const char *,point3d_t *, strless>::iterator i=point_map.find(attr);
	if(i!=point_map.end()) *(i->second)=p;
	else cerr<<"setting unexisting attr"<<attr<<endl;
	return i!=point_map.end();
}

// LIST PUSH FUNCTIONS

bool configurable_t::push(const char *attr,GFLOAT value)
{
	map<const char *,list<GFLOAT> *, strless>::iterator i=float_list_map.find(attr);
	if(i!=float_list_map.end()) i->second->push_back(value);
	else cerr<<"pushing unexisting attr"<<attr<<endl;
	return i!=float_list_map.end();
}

bool configurable_t::push(const char *attr,bool value)
{
	map<const char *,list<bool> *, strless>::iterator i=bool_list_map.find(attr);
	if(i!=bool_list_map.end()) i->second->push_back(value);
	else cerr<<"pushing unexisting attr"<<attr<<endl;
	return i!=bool_list_map.end();
}

bool configurable_t::push(const char *attr,int value)
{
	map<const char *,list<int> *, strless>::iterator i=int_list_map.find(attr);
	if(i!=int_list_map.end()) i->second->push_back(value);
	else cerr<<"pushing unexisting attr"<<attr<<endl;
	return i!=int_list_map.end();
}

bool configurable_t::push(const char *attr,const char *str)
{
	map<const char *,list<string> *, strless>::iterator i=str_list_map.find(attr);
	if(i!=str_list_map.end()) i->second->push_back(str);
	else cerr<<"pushing unexisting attr"<<attr<<endl;
	return i!=str_list_map.end();
}

bool configurable_t::push(const char *attr,const color_t &color)
{
	map<const char *,list<color_t> *, strless>::iterator i=color_list_map.find(attr);
	if(i!=color_list_map.end()) i->second->push_back(color);
	else cerr<<"pushing unexisting attr"<<attr<<endl;
	return i!=color_list_map.end();
}

bool configurable_t::push(const char *attr,const vector3d_t &vec)
{
	map<const char *,list<vector3d_t> *, strless>::iterator i=vector_list_map.find(attr);
	if(i!=vector_list_map.end()) i->second->push_back(vec);
	else cerr<<"pushing unexisting attr"<<attr<<endl;
	return i!=vector_list_map.end();
}

bool configurable_t::push(const char *attr,const point3d_t &p)
{
	map<const char *,list<point3d_t> *, strless>::iterator i=point_list_map.find(attr);
	if(i!=point_list_map.end()) i->second->push_back(p);
	else cerr<<"pushing unexisting attr"<<attr<<endl;
	return i!=point_list_map.end();
}

// REGISTER FUNCTIONS
//


void configurable_t::regist(const char *attr,GFLOAT &value)
{
	float_map[attr]=&value;
}

void configurable_t::regist(const char *attr,bool &value)
{
	bool_map[attr]=&value;
}

void configurable_t::regist(const char *attr,int &value)
{
	int_map[attr]=&value;
}

void configurable_t::regist(const char *attr,std::string &str)
{
	str_map[attr]=&str;
}

void configurable_t::regist(const char *attr,color_t &color)
{
	color_map[attr]=&color;
}

void configurable_t::regist(const char *attr,vector3d_t &vec)
{
	vector_map[attr]=&vec;
}

void configurable_t::regist(const char *attr,point3d_t &p)
{
	point_map[attr]=&p;
}

void configurable_t::regist(const char *attr,std::list<GFLOAT> &value)
{
	float_list_map[attr]=&value;
}

void configurable_t::regist(const char *attr,std::list<bool> &value)
{
	bool_list_map[attr]=&value;
}

void configurable_t::regist(const char *attr,std::list<int> &value)
{
	int_list_map[attr]=&value;
}

void configurable_t::regist(const char *attr,std::list<std::string> &str)
{
	str_list_map[attr]=&str;
}

void configurable_t::regist(const char *attr,std::list<color_t> &color)
{
	color_list_map[attr]=&color;
}

void configurable_t::regist(const char *attr,std::list<vector3d_t> &vec)
{
	vector_list_map[attr]=&vec;
}

void configurable_t::regist(const char *attr,std::list<point3d_t> &p)
{
	point_list_map[attr]=&p;
}


__END_YAFRAY
