#include <yafray/core/extern/scene.h>
#include <yafray/core/extern/tools.h>
#include <yafray/core/intern/meshtree.h>

#include <iostream>
#include <limits>

using namespace std;

__BEGIN_YAFRAY

bool scene_t::shoot(const ray_t &ray, surfacePoint_t &sp, const void *skip)const
{
	triangle_t *skiptriangle = (triangle_t *) skip;
	
  triangle_t *hitt=NULL;
  PFLOAT minZ=numeric_limits<PFLOAT>::infinity();
  //PFLOAT dis=numeric_limits<PFLOAT>::infinity();
  
	pureBspIterator_t<vector<triangle_t *> > 
		ite((tnode_t *)geometry.tree,/* dis,*/ geometry.bound, ray, false);
  for(;!ite;++ite)
  {
		v_foreach_const(triangle_t *, i, **ite)
    {
      if(skiptriangle==*i) continue;
      if(hitt==*i) continue;
      if( (*i)->hit(ray))
      {
        PFLOAT Z=(*i)->intersect(ray);
        if((Z>0) && (Z<minZ))
        {
          //ite.limit(Z);
          minZ=Z;
          hitt=(*i);
        }
      }
    }
  }
  if(hitt==NULL) return false;
  point3d_t h=ray.from+minZ*ray.dir;
  sp=hitt->getSurface(h,minZ);
  return true;

}

bool scene_t::shadow(const segment_t &seg, const void *skip1, const void *skip2)const
{
	triangle_t *skiptriangle1 = (triangle_t *) skip1;
	triangle_t *skiptriangle2 = (triangle_t *) skip2;
	
	pureBspIterator_t<vector<triangle_t *> > 
		ite((tnode_t *)geometry.tree, /*0.0  unused ,*/ geometry.bound, seg, true);
  for(;!ite;++ite)
  {
		v_foreach_const(triangle_t *, i, **ite)
    {
      if(skiptriangle1==*i) continue;
      if(skiptriangle2==*i) continue;
      if( (*i)->hit(seg))
      {
        PFLOAT Z=(*i)->intersect(seg);
        if((Z>0) && (Z<seg.dist)) return true;
      }
    }
  }
	
	return false;
}

__END_YAFRAY
