#include <yafray/core/extern/tools.h>
#include <map>
#include <iostream>

using namespace std;

__BEGIN_YAFRAY

struct mslot_t
{
	int line;
	const char *file;
};

class mtracker_t
{
	public:
		~mtracker_t();
		map<void *, mslot_t> mem;
};

mtracker_t::~mtracker_t()
{
	for(map<void *, mslot_t>::iterator i=mem.begin();i!=mem.end();++i)
		cout<<"Unfreed "<<i->first<<" file "<<i->second.file<<" line "<<i->second.line<<endl;
}


static mtracker_t tracker;

void * trackNew(void *p, const char *f, int l)
{
	mslot_t s;
	s.line=l;
	s.file=f;
	tracker.mem[p] = s;
	return p;
}

void  *trackDelete(void *p, const char *f, int l)
{
	map<void *, mslot_t>::iterator it = tracker.mem.find(p);
	if(it == tracker.mem.end())
		cout<<"Repeated free "<<p<<" file "<<f<<" line "<<l<<endl;
	else tracker.mem.erase(it);
	return p;
}

void testAllocated(const void *p, const char *f, int l)
{
	map<void *, mslot_t>::iterator it = tracker.mem.find((void *)p);
	if(it == tracker.mem.end())
		cout<<"Unallocated or deleted "<<p<<" used in file "<<f<<" line "<<l<<endl;
}


__END_YAFRAY
