#include <yafray/fry/draw.h>
#include <yafray/core/extern/tools.h>
#include <cstdlib>
#include <iostream>
#include <glut.h>

using namespace std;

static void glutdisplay()
{
	painter_t::it().update();
}

static void glutidle()
{
	painter_t::it().idle();
}

static void glutspecial(unsigned char key, int x, int y)
{
	painter_t::it().special(key, x, y);
}

painter_t::painter_t()
{
	dowork = NULL;
	glutWindow = -1;
}

void painter_t::init(int w, int h)
{
	width=w;
	height=h;
	image = _tn(new unsigned char [w*h*3]);

	int argc=1;
	char *argv[]= { "fry", NULL };
	glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(w,h);
  glutWindow=glutCreateWindow("fry"); // aqui
  glutDisplayFunc(glutdisplay);
  glutKeyboardFunc(glutspecial);
}

painter_t::~painter_t()
{
	if(glutWindow != -1)
	{
		glutDestroyWindow(glutWindow);
		delete [] _td(image);
	}
}

void painter_t::run()
{
	glutMainLoop();
}

void painter_t::update()
{
    glDisable(GL_ALPHA_TEST);
    glDisable(GL_BLEND);
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_DITHER);
    glDisable(GL_FOG);
    glDisable(GL_LIGHTING);
    glDisable(GL_LOGIC_OP);
    glDisable(GL_STENCIL_TEST);
    glDisable(GL_TEXTURE_1D);
    glDisable(GL_TEXTURE_2D);
    glPixelTransferi(GL_MAP_COLOR, GL_FALSE);
    glPixelTransferi(GL_RED_SCALE, 1);
    glPixelTransferi(GL_RED_BIAS, 0);
    glPixelTransferi(GL_GREEN_SCALE, 1);
    glPixelTransferi(GL_GREEN_BIAS, 0);
    glPixelTransferi(GL_BLUE_SCALE, 1);
    glPixelTransferi(GL_BLUE_BIAS, 0);
    glPixelTransferi(GL_ALPHA_SCALE, 1);
    glPixelTransferi(GL_ALPHA_BIAS, 0);


	glClearColor(0,0,0,0);
	glClear( GL_COLOR_BUFFER_BIT );
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//glOrtho(-1,1,-1,1,1,10);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	glRasterPos2i(-1, 1);
	glPixelZoom(1.0, -1.0);
	glDrawPixels(width, height, GL_RGB, GL_UNSIGNED_BYTE, image);
	
	glFinish();
	glutSwapBuffers();
}

void painter_t::darken()
{
	for(int y=0;y<height;++y)
	{
		int off=y*width*3;
		if(y%2)
			for(int i=0;i<(3*width); i+=3)
			{
				image[off+i]=image[off+i]/2;
				image[off+i+1]=image[off+i+1]/2;
				image[off+i+2]=image[off+i+2]/2;
			}
	}
}

void painter_t::display()
{
	glutPostRedisplay();
}

void painter_t::setWork(void (*dw)(void *), void *a) 
{
	if(dw != NULL)
	{
		dowork = dw; 
		arg = a;
  	glutIdleFunc(glutidle);
	}
	else
	{
		dowork = NULL;
  	glutIdleFunc(NULL);
	}
}

void painter_t::special(int key, int x, int y)
{
	switch(key)
	{
		case 27: exit(0); break;
		case 13: wannafinish = true; break;
	}
}

painter_t & painter_t::it()
{
	static painter_t P;
	return P;
}

